require "active_support/inflector"

module Creamerscript
  module Sweeteners
    def self.register(sweetener)
      sweetener.new.tap { |s| sweeteners[s.type] = s }
    end

    def self.each
      sweeteners.each { |type, sweetener| yield sweetener }
    end

    def self.for(type)
      sweeteners[type]
    end

    def self.sweeteners
      @sweeteners ||= {}
    end
  end
end
